| Qore GmailDataProvider Module Reference 1.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | List of all members
GmailDataProvider::GmailMessageWatchDataProvider Class Reference

The parent class for Gmail REST APIs. More...

`#include <GmailMessageWatchDataProvider.qc.dox.h>`

Inheritance diagram for GmailDataProvider::GmailMessageWatchDataProvider:
[legend]

## Public Member Functions
| constructor (GoogleRestClient::GoogleRestClient rest, *hash< auto > options)
| Creates the object from a REST connection.
*string | getDesc ()
| Returns the data provider description.
string | getName ()
| Returns the data provider name.
Public Member Functions inherited from GmailDataProvider::GmailMessageWatchDataProviderBase
| constructor (GoogleRestClient::GoogleRestClient rest, hash< string, hash< DataProviderOptionInfo > > constructor_options, *hash< auto > options)
| Creates the object from a REST connection.
| destructor ()
| Stops observing and deletes the object.
| observersReady ()
| Called when all observers have been added to the object.
| stopEvents ()
| Called to stop generating events.

## Static Public Member Functions
static AbstractDataProviderType | getMessageEventType ()
| Returns the message event data type.

## Public Attributes
const | ProviderInfo = ...
| Provider info.
const | ProviderSummaryInfo = ...
| Provider summary info.
Public Attributes inherited from GmailDataProvider::GmailMessageWatchDataProviderBase
const | ConstructorOptions = ...
| Constructor options.
const | MinPollInterval = 30
| Minimum poll interval in seconds.
const | MonthMap = ...
| For parsing months.

## Protected Member Functions
hash< string, hash< DataProviderMessageInfo > > | getEventTypesImpl ()
| Returns a hash of all supported event types.
auto | getExampleEventDataImpl (string event_id)
| Returns example data for the given observable event.
hash< DataProvider::DataProviderInfo > | getStaticInfoImpl ()
| Returns data provider static info.
| messageReceived (hash< auto > msg)
| Raise events.
Protected Member Functions inherited from GmailDataProvider::GmailMessageWatchDataProviderBase
Condition | cond ()
| I/O Condition.
hash< auto > | getAttachment (hash< auto > att, *hash< auto > hdr)
| Returns attachment data.
abstract | messageReceived (hash< auto > msg)
| Raise events.
*hash< auto > | pollOnce (reference< hash< auto > > setup)
| Perform one poll.
| pollThread ()
| I/O polling thread.
| processBody (*reference< hash< auto > > msg)
| Process body.
| processHeaders (*reference< hash< auto > > msg, hash< auto > fields, *hash< auto > pfields)
| Process headers and body.
| processOptions (*hash< auto > copts)
| Process constructor options.
hash< auto > | setup ()
| Setup for a poll operation.
| stopIntern ()
| Stops polling.

## Additional Inherited Members
Static Protected Member Functions inherited from GmailDataProvider::GmailMessageWatchDataProviderBase
static auto | getHeaderValue (string val)
| Get header value.
static auto | getHeaderValue (string val, hash< auto > f)
| Get header value.
Protected Attributes inherited from GmailDataProvider::GmailMessageWatchDataProviderBase
bool | delete_messages
| Delete emails after retreiving.
int | io_tid
| I/O TID.
int | poll_secs
| Poll interval in seconds.
string | q
| Match query.
bool | retrieve_attachments
| Retrieve attachments.
date | start_date
| Start date for scan.
bool | stop
| I/O stop flag.
int | waiting
| Number of threads waiting on the I/O condition.

## Detailed Description

The parent class for Gmail REST APIs.

## Member Function Documentation

## ◆ getEventTypesImpl()

hash< string, hash< DataProviderMessageInfo > > GmailDataProvider::GmailMessageWatchDataProvider::getEventTypesImpl | ( |  | ) |
| protected

Returns a hash of all supported event types.

Returns
  a hash of all supported event types

Note
  only called if the provider supports the observer pattern / event API

## ◆ getExampleEventDataImpl()

auto GmailDataProvider::GmailMessageWatchDataProvider::getExampleEventDataImpl | ( | string | event_id | ) |
| protected

Returns example data for the given observable event.

Parameters

  event_id | the event ID of the event

Returns
  example data for the given observable event

Exceptions

  INVALID-OPERATION | the data provider does not support the observer pattern / event API
  INVALID-EVENT | the event_id is not valid

Since
  DataProvider 3.0